/*
LESS variables are information about icon's compiled state, stored under its original file name

.icon-home {
  width: @icon-home-width;
}

The large array-like variables contain all information about a single icon
@icon-home: x y offset_x offset_y width height total_width total_height image_path name;

At the bottom of this section, we provide information about the spritesheet itself
@spritesheet: width height image @spritesheet-sprites;
*/
@ico-arrow-name: 'ico-arrow';
@ico-arrow-x: 0px;
@ico-arrow-y: 0px;
@ico-arrow-offset-x: 0px;
@ico-arrow-offset-y: 0px;
@ico-arrow-width: 22px;
@ico-arrow-height: 18px;
@ico-arrow-total-width: 44px;
@ico-arrow-total-height: 185px;
@ico-arrow-image: '../images/sprites/sprites.png';
@ico-arrow: 0px 0px 0px 0px 22px 18px 44px 185px '../images/sprites/sprites.png' 'ico-arrow';
@ico-basket-arrow-name: 'ico-basket-arrow';
@ico-basket-arrow-x: 0px;
@ico-basket-arrow-y: 40px;
@ico-basket-arrow-offset-x: 0px;
@ico-basket-arrow-offset-y: -40px;
@ico-basket-arrow-width: 32px;
@ico-basket-arrow-height: 19px;
@ico-basket-arrow-total-width: 44px;
@ico-basket-arrow-total-height: 185px;
@ico-basket-arrow-image: '../images/sprites/sprites.png';
@ico-basket-arrow: 0px 40px 0px -40px 32px 19px 44px 185px '../images/sprites/sprites.png' 'ico-basket-arrow';
@ico-basket-big-name: 'ico-basket-big';
@ico-basket-big-x: 0px;
@ico-basket-big-y: 144px;
@ico-basket-big-offset-x: 0px;
@ico-basket-big-offset-y: -144px;
@ico-basket-big-width: 44px;
@ico-basket-big-height: 41px;
@ico-basket-big-total-width: 44px;
@ico-basket-big-total-height: 185px;
@ico-basket-big-image: '../images/sprites/sprites.png';
@ico-basket-big: 0px 144px 0px -144px 44px 41px 44px 185px '../images/sprites/sprites.png' 'ico-basket-big';
@ico-basket-medium-name: 'ico-basket-medium';
@ico-basket-medium-x: 0px;
@ico-basket-medium-y: 61px;
@ico-basket-medium-offset-x: 0px;
@ico-basket-medium-offset-y: -61px;
@ico-basket-medium-width: 25px;
@ico-basket-medium-height: 23px;
@ico-basket-medium-total-width: 44px;
@ico-basket-medium-total-height: 185px;
@ico-basket-medium-image: '../images/sprites/sprites.png';
@ico-basket-medium: 0px 61px 0px -61px 25px 23px 44px 185px '../images/sprites/sprites.png' 'ico-basket-medium';
@ico-basket-name: 'ico-basket';
@ico-basket-x: 0px;
@ico-basket-y: 20px;
@ico-basket-offset-x: 0px;
@ico-basket-offset-y: -20px;
@ico-basket-width: 20px;
@ico-basket-height: 18px;
@ico-basket-total-width: 44px;
@ico-basket-total-height: 185px;
@ico-basket-image: '../images/sprites/sprites.png';
@ico-basket: 0px 20px 0px -20px 20px 18px 44px 185px '../images/sprites/sprites.png' 'ico-basket';
@ico-del-name: 'ico-del';
@ico-del-x: 0px;
@ico-del-y: 86px;
@ico-del-offset-x: 0px;
@ico-del-offset-y: -86px;
@ico-del-width: 30px;
@ico-del-height: 25px;
@ico-del-total-width: 44px;
@ico-del-total-height: 185px;
@ico-del-image: '../images/sprites/sprites.png';
@ico-del: 0px 86px 0px -86px 30px 25px 44px 185px '../images/sprites/sprites.png' 'ico-del';
@ico-go-name: 'ico-go';
@ico-go-x: 0px;
@ico-go-y: 113px;
@ico-go-offset-x: 0px;
@ico-go-offset-y: -113px;
@ico-go-width: 29px;
@ico-go-height: 29px;
@ico-go-total-width: 44px;
@ico-go-total-height: 185px;
@ico-go-image: '../images/sprites/sprites.png';
@ico-go: 0px 113px 0px -113px 29px 29px 44px 185px '../images/sprites/sprites.png' 'ico-go';
@spritesheet-width: 44px;
@spritesheet-height: 185px;
@spritesheet-image: '../images/sprites/sprites.png';
@spritesheet-sprites: @ico-arrow @ico-basket-arrow @ico-basket-big @ico-basket-medium @ico-basket @ico-del @ico-go;
@spritesheet: 44px 185px '../images/sprites/sprites.png' @spritesheet-sprites;

/*
The provided classes are intended to be used with the array-like variables

.icon-home {
  .sprite-width(@icon-home);
}
.icon-email {
  .sprite(@icon-email);
}
*/
.sprite-width(@sprite) {
  width: extract(@sprite, 5);
}

.sprite-height(@sprite) {
  height: extract(@sprite, 6);
}

.sprite-position(@sprite) {
  @sprite-offset-x: extract(@sprite, 3);
  @sprite-offset-y: extract(@sprite, 4);
  background-position: @sprite-offset-x @sprite-offset-y;
}

.sprite-image(@sprite) {
  @sprite-image: extract(@sprite, 9);
  @sprite-image-bare: ~`"@{sprite-image}".slice(1, -1)`;
  background-image: url(@sprite-image-bare);
}

.sprite(@sprite) {
  .sprite-image(@sprite);
  .sprite-position(@sprite);
  .sprite-width(@sprite);
  .sprite-height(@sprite);
}

/*
The `.sprites` mixin generates identical output to the CSS template
  but can be overridden inside of LESS

This must be run when you have at least 2 sprites.
  If run with a single sprite, then there will be reference errors.

.sprites(@spritesheet-sprites);
*/
.sprites(@sprites, @i: 1) when (@i <= length(@sprites)) {
  @sprite: extract(@sprites, @i);
  @sprite-name: e(extract(@sprite, 10));
  .@{sprite-name} {
    .sprite(@sprite);
  }
  .sprites(@sprites, @i + 1);
}
